function draw.init()

	local layers = 5
	local font = {}
	local message	= {}
	local timer = {}
	local alpha = {}
	local fade	= {}
	local speed = {}
	local x = {}
	local y = {}
	local r = {}
	local g = {}
	local b = {}

	function draw.message(Layer, Font, Message, X, Y, Timer, R, G, B)
		if message then
			font[Layer] = Font
			message[Layer] = Message
			timer[Layer] = Timer
			alpha[Layer] = 255
			fade[Layer] = 100
			x[Layer] = X
			y[Layer] = Y
			r[Layer] = R
			g[Layer] = G
			b[Layer] = B
			speed[Layer] = 255/fade[Layer]
		end
	end
		
	function draw.update()	
		for layer = 0, layers do
			if message[layer] then
				if timer[layer] > 0 then
					timer[layer] = timer[layer] - 1
					if timer[layer] < fade[layer] and alpha[layer] > 0 then 
						alpha[layer] = alpha[layer] - speed[layer]
					end
					if alpha[layer] < 0 then 
						alpha[layer] = 0 
					end
				end
			end   
		end
	end

	function bindings.afterUpdate()
		draw.update()
	end

	function draw.render(bitmap)
		for layer = 0, layers do
			if message[layer] then
				gfx_set_alpha(alpha[layer])
					font[layer]:render(bitmap, message[layer], x[layer], y[layer], color(r[layer], g[layer] ,b[layer]), Font.CenterH+Font.CenterV+Font.Shadow)
				gfx_reset_blending()
			end			
		end
	end

	function bindings.viewportRender(viewport, worm)
		local bitmap = viewport:bitmap()
		for layer = 0, layers do
			if message[layer] then
				if timer[layer] > 0 then 
					draw.render(bitmap) 
				end
			end
		end
	end
end