function promode.init()

	debugState = false
	gameEnd = 0
	
	console.p0_team = 0
	console.p1_team = 0
	
	weaponsList = {"Bazooka", "Chaingun", "Doomsday", "Flak Cannon", "Grenade Launcher", "Gauss Gun", "Grenade", "Lightning Gun", "Mortar", "Rifle", "Shotgun", "Winchester"}

	function bindings.playerInit(p)
		local d = p:data()
		
		d.hits = {}
		d.atts = {}
		d.awards = {}
	
		for i = 1,table.getn(weaponsList) do
			d.hits[weaponsList[i]] = 0
			d.atts[weaponsList[i]] = 0
		end
		
		d.hits["Gauss Gun "] = 0
		d.atts["Gauss Gun "] = 0
	
		for i = 0,2 do
			d.awards[i] = 0
		end
	end

	if AUTH then
		gameMode = tonumber(console.sv_team_play)
		if gameMode == 0 then
			gameMode = 1
		end
	else
		gameMode = 0
	end
		
	function debug(string)
		if debugState then
			print(string)
		end
	end
	
	local netMode = network_game_event("net_mode", function(self, data)
		local serverMode = data:get_int()
		
		if serverMode ~= gameMode then
			debug("Server game mode: "..serverMode..", client game mode "..gameMode)
			gameMode = serverMode
			debug("Update: Server game mode: "..serverMode..", client game mode "..gameMode)
			weaponsel.init()
			mainm.init()
			teamm.init()
			spectator.init()
			stats.init()
			console.exec = "pmconfig.cfg"
		end
	end)
    
	function promode.sendMode(clients)
		if not clients then 
			clients = 0 
		end
	
		local data = new_bitstream()
		data:add_int(gameMode)
	
		netMode:send(data, clients, SendMode.ReliableOrdered, RepRule.Auth2All)
	end
	
	function bindings.playerNetworkInit(newb, connID)
		if AUTH then
			promode.sendMode(connID)
		end
	end
	
	function promode.svsay(msg)
		if AUTH and DEDSERV then
			game_local_player(0):say("02"..string.upper(msg).."00")
		end
	end
	
	chat.init()
	limits.init()
	mode.init()
	damage.init()
	scoreboard.init()
	hud.init()
	ircbot.init()
	weaponeffects.init()
	effects.init()
	draw.init()
	vote.init()
	weaponsyncing.init()

	console_register_command("SHOWMENU", function()
		mainm.show()
	end)
	
	console_register_command("SHOWTEAMMENU", function()
		teamm.show()
	end)

	if AUTH then
		if not DEDSERV then
			mainm.init()
			teamm.init()
		end
		weaponsel.init()
		spectator.init()
		stats.init()
		console.exec = "pmconfig.cfg"
	end

	if not DEDSERV then
		if map_is_loaded() then
			draw.message(0, fonts.liero, "Gusanos Promode v.100b", 160, 170, 500, 0, 254, 254)
			draw.message(1, fonts.liero, "http://pro.wesz.rtu.pl/", 160, 179, 500, 255, 255, 0)
		end
	end
	
	if DEDSERV then
		dedserv.init()
	end
	
	debug("Game mode: "..gameMode)
beretta.init()
		end
