function scoreboard.init()

	function strip(string)
		return string.gsub(string, "[%d%s%a%c][%d%s%a%c]", "")
	end
	
	if not DEDSERV then
		local scoreVisible = false
		
		console_register_command("+SCORES", function()
			scoreVisible = true
		end)
			
		console_register_command("-SCORES", function()
			scoreVisible = false
		end)

		function bindings.viewportRender(viewport, worm)
			local bitmap = viewport:bitmap()
			local p = worm:player()
			local height = 61
			local tdmHeight = 75
			
			if scoreVisible or gameEnd > 0 then
				if gameMode == 2 then
					local playerList = {}
					
					for pl in game_players() do
						if pl:team() ~= 0 then
							table.insert(playerList, {pl:name(), pl:kills(), pl:deaths(), floor(pl:stats().timer / 6000), pl})
						end	
					end
					
					gfx_set_alpha(50)
						bitmap:draw_box(40, 25, 279, 135, color(20, 20, 20))
					gfx_reset_blending()
					
					if playerList[1] then
						fonts.bigfont:render(bitmap, playerList[1][2], 140, 28, color(255, 255, 255), Font.Right + Font.Shadow)
						fonts.liero:render(bitmap, playerList[1][1], 110, 28, color(255, 255, 255), Font.Right + Font.Shadow + Font.Formatting)
						fonts.liero:render(bitmap, playerList[1][4], 140, 46, color(0, 255, 0), Font.Right + Font.Shadow + Font.Formatting)
						for i = 1, 5 do
							if playerList[1][5]:data().atts[playerList[1][5]:data().weaponSelection.list[i]:name()] > 0 then
								fonts.liero:render(bitmap, floor((playerList[1][5]:data().hits[playerList[1][5]:data().weaponSelection.list[i]:name()] / playerList[1][5]:data().atts[playerList[1][5]:data().weaponSelection.list[i]:name()]) * 100).." %", 130, 50 + (9 * i), color(255, 255, 255), Font.Right + Font.Shadow + Font.Formatting)
								fonts.liero:render(bitmap, "06"..playerList[1][5]:data().hits[playerList[1][5]:data().weaponSelection.list[i]:name()].."/ "..playerList[1][5]:data().atts[playerList[1][5]:data().weaponSelection.list[i]:name()].."00", 95, 50 + (9 * i), color(255, 255, 255), Font.Right + Font.Shadow + Font.Formatting)
							end
						end
					end
					
					if playerList[2] then
						fonts.bigfont:render(bitmap, playerList[2][2], 180, 28, color(255, 255, 255), Font.Right + Font.Shadow)
						fonts.liero:render(bitmap, playerList[2][1], 230, 28, color(255, 255, 255), Font.Right + Font.Shadow + Font.Formatting)
						fonts.liero:render(bitmap, playerList[2][4], 180, 46, color(0, 255, 0), Font.Right + Font.Shadow + Font.Formatting)
						for i = 1, 5 do
							if playerList[2][5]:data().atts[playerList[2][5]:data().weaponSelection.list[i]:name()] > 0 then
								fonts.liero:render(bitmap, floor((playerList[2][5]:data().hits[playerList[2][5]:data().weaponSelection.list[i]:name()] / playerList[2][5]:data().atts[playerList[2][5]:data().weaponSelection.list[i]:name()]) * 100).." %", 201, 50 + (9 * i), color(255, 255, 255), Font.Right + Font.Shadow + Font.Formatting)
								fonts.liero:render(bitmap, "06"..playerList[2][5]:data().hits[playerList[2][5]:data().weaponSelection.list[i]:name()].."/ "..playerList[2][5]:data().atts[playerList[2][5]:data().weaponSelection.list[i]:name()].."00", 232, 50 + (9 * i), color(255, 255, 255), Font.Right + Font.Shadow + Font.Formatting)
							end
						end
					end
				elseif gameMode == 3 or gameMode == 4 then
					local scoreRed = 0
					local scoreBlue = 0
					local playerListRed = {}
					local playerListBlue = {}
					
					for pl in game_players() do
						if pl:team()  == 1 then
							table.insert(playerListRed, {pl:name(), pl:kills(), pl:deaths(), floor(pl:stats().timer / 6000)})
						end
						
						if pl:team() == 2 then
							table.insert(playerListBlue, {pl:name(), pl:kills(), pl:deaths(), floor(pl:stats().timer / 6000)})
						end
					end
	
					scoreboardRed = {}
					scoreboardBlue = {}
	
					for index, sort in ipairs(playerListRed) do
						if #scoreboardRed > 0 then
							local name, sort_score = unpack(sort)
							local sorted = false		
		
							for index, scores in ipairs(scoreboardRed) do
								local name, score = unpack(scores)
								if sort_score >= score then
									table.insert(scoreboardRed,index, sort)
									sorted = true
									break
								end
							end
		
							if not sorted then
								table.insert(scoreboardRed, sort)
							end
						else 
							table.insert(scoreboardRed, sort)	
						end
					end
					for index, sort in ipairs(playerListBlue) do
						if #scoreboardBlue > 0 then
							local name, sort_score = unpack(sort)
							local sorted = false		
		
							for index, scores in ipairs(scoreboardBlue) do
								local name, score = unpack(scores)
								if sort_score >= score then
									table.insert(scoreboardBlue,index, sort)
									sorted = true
									break
								end
							end
		
							if not sorted then
								table.insert(scoreboardBlue, sort)
							end
						else 
							table.insert(scoreboardBlue, sort)	
						end
					end
					
					gfx_set_alphach(30)
						bitmap:draw_box(21, 49, 160, 72, color(255, 0, 0))
						bitmap:draw_box(165, 49, 304, 72, color(0, 0, 255))
					gfx_reset_blending()
					gfx_set_alphach(60)
						bitmap:draw_box(21, 73, 160, 82+(9*table.getn(playerListRed)), color(255, 0, 0))
						bitmap:draw_box(165, 73, 304, 82+(9*table.getn(playerListBlue)), color(0, 0, 255))
					gfx_reset_blending()
					
					fonts.liero:render(bitmap, "Players", 132, 51, color(255, 0, 0), Font.Shadow)
					fonts.liero:render(bitmap, "Players", 275, 51, color(0, 0, 255), Font.Shadow)
					fonts.liero:render(bitmap, table.getn(playerListRed), 159, 62, color(255, 255, 255), Font.Right + Font.Shadow)
					fonts.liero:render(bitmap, table.getn(playerListBlue), 302, 62, color(255, 255, 255), Font.Right + Font.Shadow)
					
					for players = 1, table.getn(scoreboardRed) do
						scoreRed = scoreRed + scoreboardRed[players][2]
					end
					
					for players = 1, table.getn(scoreboardBlue) do
						scoreBlue = scoreBlue + scoreboardBlue[players][2]
					end
					fonts.bigfont:render(bitmap, scoreRed, 25, 54, color(255, 255, 255), Font.Shadow )
					fonts.bigfont:render(bitmap, scoreBlue, 169, 54, color(255, 255, 255), Font.Shadow )
					fonts.minifont:render(bitmap, "Name", 103, 75, color(255, 0, 0), Font.Shadow)
					fonts.minifont:render(bitmap, "Net", 84, 75, color(255, 0, 0), Font.Shadow)
					fonts.minifont:render(bitmap, "Deaths", 53, 75, color(255, 0, 0), Font.Shadow)
					fonts.minifont:render(bitmap, "Score", 27, 75, color(255, 0, 0), Font.Shadow)
					fonts.minifont:render(bitmap, "Name", 247, 75, color(0, 0, 255), Font.Shadow)
					fonts.minifont:render(bitmap, "Net", 228, 75, color(0, 0, 255), Font.Shadow)
					fonts.minifont:render(bitmap, "Deaths", 197, 75, color(0, 0, 255), Font.Shadow)
					fonts.minifont:render(bitmap, "Score", 171, 75, color(0, 0, 255), Font.Shadow)
					
					for players = 1, table.getn(scoreboardRed) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardRed[players][1], 103, tdmHeight, color(255,255,255), Font.Shadow + Font.Formatting)
					end
					
					tdmHeight = 75
					for players = 1, table.getn(scoreboardRed) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardRed[players][2] - scoreboardRed[players][3], 96, tdmHeight, color(100,254,254), Font.Right + Font.Shadow)
					end
					
					tdmHeight = 75
					for players = 1, table.getn(scoreboardRed) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardRed[players][3], 77, tdmHeight, color(255,0,0), Font.Right + Font.Shadow)
					end
					
					tdmHeight = 75
					for players = 1, table.getn(scoreboardRed) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardRed[players][2], 47, tdmHeight, color(0,255,0), Font.Right + Font.Shadow)
					end
					
					tdmHeight = 75
					for players = 1, table.getn(scoreboardBlue) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardBlue[players][1], 247, tdmHeight, color(255,255,255), Font.Shadow + Font.Formatting)
					end
					
					tdmHeight = 75
					for players = 1, table.getn(scoreboardBlue) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardBlue[players][2] - scoreboardBlue[players][3], 240, tdmHeight, color(100,254,254), Font.Right + Font.Shadow)
					end
					
					tdmHeight = 75
					for players = 1, table.getn(scoreboardBlue) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardBlue[players][3], 221, tdmHeight, color(255,0,0), Font.Right + Font.Shadow)
					end
					
					tdmHeight = 75
					for players = 1, table.getn(scoreboardBlue) do
						tdmHeight = tdmHeight  + 9
						fonts.minifont:render(bitmap, scoreboardBlue[players][2], 191, tdmHeight, color(0,255,0), Font.Right + Font.Shadow)
					end
					
					if table.getn(scoreboardRed) > table.getn(scoreboardBlue) then
						height = 67 + (9 * table.getn(scoreboardRed)) + 28
					else
						height = 67 + (9 * table.getn(scoreboardBlue)) + 28
					end
					
					fonts.liero:render(bitmap, "Spectators", 160, height, color(255, 255, 0), Font.CenterH+Font.CenterV+Font.Shadow)
					local spectators = {}
					for spct in game_players() do
						if spct:team() == 0 then
							table.insert(spectators, spct:name())
						end
					end
					
					spctLine = 1
					spcts = table.getn(spectators)
					
					for i = 1, spcts do
						fonts.liero:render(bitmap, spectators[i], (60*i), height + 9, color(255, 255, 255), Font.Shadow + Font.Formatting)
					end
				else
					local playerList = {}
					
					for pl in game_players() do
						if pl:team() ~= 0 then
							if gameMode == 6 then
								table.insert(playerList, {pl:name(), pl:stats().kotb_timer, pl:kills(), pl:deaths()})
							else
								table.insert(playerList, {pl:name(), pl:kills(), pl:deaths(), floor(pl:stats().timer / 6000)})
							end
						end	
					end
	
					scoreboard = {}
	
					for index, sort in ipairs(playerList) do
						if #scoreboard > 0 then
							local name, sort_score = unpack(sort)
							local sorted = false		
		
							for index, scores in ipairs(scoreboard) do
								local name, score = unpack(scores)
								if sort_score >= score then
									table.insert(scoreboard,index, sort)
									sorted = true
									break
								end
							end
		
							if not sorted then
								table.insert(scoreboard, sort)
							end
						else 
							table.insert(scoreboard, sort)	
						end
					end
					
					gfx_set_alpha(50)
						bitmap:draw_box(60, 68, 260, 76, color(220, 220, 220))
					gfx_reset_blending()
					
					fonts.liero:render(bitmap, "Name", 171, height, color(255,255,0), Font.Shadow)
					for players = 1, table.getn(scoreboard) do
						height = height  + 9
						fonts.liero:render(bitmap, scoreboard[players][1], 171, height, color(255,255,255), Font.Shadow + Font.Formatting)
					end
					
					if gameMode == 6 then
						height = 61
						fonts.liero:render(bitmap, "Score", 80, height, color(255, 255, 0), Font.Shadow)
						for players = 1, table.getn(scoreboard) do
							height = height + 9
							fonts.liero:render(bitmap, scoreboard[players][3], 101, height, color(0, 255, 0), Font.Right + Font.Shadow)
						end
						
						height = 61
						fonts.liero:render(bitmap, "Deaths", 105, height, color(255, 255, 0), Font.Shadow)
						for players = 1, table.getn(scoreboard) do
							height = height + 9
							fonts.liero:render(bitmap, scoreboard[players][4], 130, height, color(255, 0, 0), Font.Right + Font.Shadow)
						end
						
						height = 61
						fonts.liero:render(bitmap, "Time", 150, height, color(255,255,0), Font.Shadow)
						for players = 1, table.getn(scoreboard) do
							height = height + 9
							fonts.liero:render(bitmap, to_time_string(scoreboard[players][2]), 167, height, color(100, 254, 254), Font.Right + Font.Shadow)
						end
					else
						height = 61
						fonts.liero:render(bitmap, "Min", 155, height, color(255,255,0), Font.Shadow)
						for players = 1, table.getn(scoreboard) do
							height = height + 9
							fonts.liero:render(bitmap, scoreboard[players][4], 167, height, color(100, 254, 254), Font.Right + Font.Shadow)
						end
						
						height = 61
						fonts.liero:render(bitmap, "Net", 137, height, color(255, 255, 0), Font.Shadow)
						for players = 1, table.getn(scoreboard) do
							height = height + 9
							fonts.liero:render(bitmap, scoreboard[players][2] - scoreboard[players][3], 150, height, color(255, 255, 255), Font.Right + Font.Shadow)
						end
						
						height = 61
						fonts.liero:render(bitmap, "Deaths", 105, height, color(255, 255, 0), Font.Shadow)
						for players = 1, table.getn(scoreboard) do
							height = height + 9
							fonts.liero:render(bitmap, scoreboard[players][3], 130, height, color(255, 0, 0), Font.Right + Font.Shadow)
						end
						
						height = 61
						fonts.liero:render(bitmap, "Score", 80, height, color(255, 255, 0), Font.Shadow)
						for players = 1, table.getn(scoreboard) do
							height = height + 9
							fonts.liero:render(bitmap, scoreboard[players][2], 101, height, color(0, 255, 0), Font.Right + Font.Shadow)
						end
					end
					height = 69 + (9 * table.getn(scoreboard)) + 18
					fonts.liero:render(bitmap, "Spectators", 160, height, color(255, 255, 0), Font.CenterH+Font.CenterV+Font.Shadow)
					local spectators = {}
					for spct in game_players() do
						if spct:team() == 0 then
							table.insert(spectators, spct:name())
						end
					end
					
					spctLine = 1
					spcts = table.getn(spectators)
					
					for i = 1, spcts do
						--if spcts <= 3 then
							fonts.liero:render(bitmap, spectators[i], (60*i), height + 9, color(255, 255, 255), Font.Shadow + Font.Formatting)
						--end
					end
				end			
			end
		end
	end
end
