function stats.init()

	if gameMode ~= 5 then
		weaponsCount = 5
	else
		weaponsCount = 1
	end
    
	function stats.add(worm, type, tableItem)
		local p = worm:player()
		local d = p:data()
	
		if gameEnd == 0 then
			if tableItem ~= "null" then
				if type == "hits" then
					d.hits[tableItem] = d.hits[tableItem] + 1	
				elseif type == "atts" then
						d.atts[tableItem] = d.atts[tableItem] + 1
				elseif type == "awards" then
					d.awards[tableItem] = d.awards[tableItem] + 1
				else
					debug("Unknow statistic type")
				end
			end
		end
	end
	
	function stats.lightning(object)
		stats.add(object, "atts", "Lightning Gun")
	end

	function stats.chaingun(object)
		stats.add(object, "atts", "Chaingun")
	end
	
	function stats.rifle(object)
		stats.add(object, "atts", "Rifle")
	end
	
	function stats.gauss(object)
		if gameMode == 5 then
			stats.add(object, "atts", "Gauss Gun ")
		else
			stats.add(object, "atts", "Gauss Gun")
		end
	end
	
	function stats.winchester(object)
		stats.add(object, "atts", "Winchester")
	end
	
	function stats.flak(object)
		stats.add(object, "atts", "Flak Cannon")
	end
	
	function stats.bazooka(object)
		stats.add(object, "atts", "Bazooka")
	end
	
	function stats.shotgun(object)
		stats.add(object, "atts", "Shotgun")
	end

	function stats.grenade(object)
		stats.add(object, "atts", "Grenade")
	end

	function stats.grenade_launcher(object)
		stats.add(object, "atts", "Grenade Launcher")
	end	

	function stats.doomsday(object)
		stats.add(object, "atts", "Doomsday")
	end

	function stats.mortar(object)
		stats.add(object, "atts", "Mortar")
	end
	
	function stats.drawBox(bitmap, filled, x, y, width, height)
		gfx_set_alpha(100)
			bitmap:draw_box(x, y, x+width, y+height, color(0,0,0))
			bitmap:draw_box(x+1, y+1, x+1+(width-2), y+height-1, color(22,52,18))
		gfx_reset_blending()
	end
    
	function bindings.viewportRender(viewport, worm)
		local bitmap = viewport:bitmap()
		local p = worm:player()
		local d = p:data()
		local leftMarign = 0
		local topMargin = 0
				
		if not DEDSERV and gameEnd > 0 and gameMode ~= 2 then
			gfx_set_alpha(255)
				stats.drawBox(bitmap, 0 , bitmap:w()/30, 150, 150, 80)
			gfx_reset_blending()
			
			fonts.minifont:render( bitmap, "05Score00" , bitmap:w()/30+21, 152, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "03Klls00" , bitmap:w()/30+46, 152, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "02Dths00" , bitmap:w()/30+71, 152, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "02Sui00" , bitmap:w()/30+96, 152, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "05Effcny00" , bitmap:w()/30+136, 152, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, p:kills() , bitmap:w()/30+21, 158, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, p:kills() , bitmap:w()/30+46, 158, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, p:deaths(), bitmap:w()/30+71, 158, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "0", bitmap:w()/30+95, 158, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, floor(p:kills()/(p:kills()+p:deaths())*100) .. " %", bitmap:w()/30+136, 158, color(255, 255, 255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "06Weapon00" , bitmap:w()/30+25, 170, color(255,255,255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "05Accrcy00" , bitmap:w()/30+80, 170, color(255,255,255), Font.Formatting + Font.Right )
			fonts.minifont:render( bitmap, "Atts/Hits" , bitmap:w()/30+130, 170, color(255,255,255), Font.Formatting + Font.Right )
	
			for i = 1, weaponsCount do
				fonts.minifont:render(bitmap, d.weaponSelection.list[i]:name(), bitmap:w()/30 + 1, 176 + topMargin, color(255, 255, 255),  Font.Formatting)
				fonts.minifont:render(bitmap, d.atts[d.weaponSelection.list[i]:name()] .. "/", bitmap:w()/30 + 114, 176 + topMargin, color(255, 255, 255), Font.Formatting + Font.Right)
				fonts.minifont:render(bitmap, d.hits[d.weaponSelection.list[i]:name()], bitmap:w()/30 + 114, 176 + topMargin, color(255, 255, 255), Font.Left)
				if d.atts[d.weaponSelection.list[i]:name()] > 0 then
					fonts.minifont:render(bitmap, floor((d.hits[d.weaponSelection.list[i]:name()] / d.atts[p:data().weaponSelection.list[i]:name()]) * 100) .. " %", bitmap:w()/30 + 80, 176 + topMargin, color(255, 255, 255), Font.Formatting + Font.Right)
				end
				topMargin = topMargin + 6
			end
		end
	end
end
