function vote.init()

	function bindings.playerInit(p)
		local d = p:data()
		
		d.canVote = true
	end

	vote["yes"] = 0
	vote["no"] = 0
	voteInProgress = false
	globalVote = ""
	globalVoteChoose = ""
	voteTime = 0
		
	local voteStart = network_game_event("voteStart", function(self, player, vote_data)
		voteInProgress = true
		player:data().canVote = true
		vote["yes"] = 0
		vote["no"] = 0
	end)
	
	local voteStop = network_game_event("voteStop", function(self, player, vote_data)
		voteInProgress = false
		player:data().canVote = true
		globalVote = ""
		globalVoteChoose = ""
		vote["yes"] = 0
		vote["no"] = 0
	end)
	
	local svote = network_player_event("ServerMode", 	
	function(self, player, data2)
		if not player:is_local() then
			vote["yes"] = data2:get_int()
			vote["no"] = data2:get_int()
			globalVote = data2:get_string()
			globalVoteChoose = data2:get_string()
			voteInProgress = data2:get_bool()
 		end
	end)

	local pvote = network_player_event("PlayerMode", 	
	function(self, player, data)
		if AUTH then
			if not player:is_local() then
				vote["yes"] = data:get_int()
				vote["no"] = data:get_int()
				globalVote = data:get_string()
				globalVoteChoose = data:get_string()
				voteInProgress = data:get_bool()
				local data2 = new_bitstream()
				data2:add_int(vote["yes"])
				data2:add_int(vote["no"])
				data2:add_string(globalVote)
				data2:add_string(globalVoteChoose)
				data2:add_bool(voteInProgress)
				svote:send(player,data2)
 			end
		else
			if not player:is_local() then
				vote["yes"] = data:get_int()
				vote["no"] = data:get_int()
				globalVote = data:get_string()
				globalVoteChoose = data:get_string()
				voteInProgress = data:get_bool()
 			end
		end
	end)	
 		
	function syncVote(player,connID)
		local data = new_bitstream()
		data:add_int(vote["yes"])
		data:add_int(vote["no"])
		data:add_string(globalVote)
		data:add_string(globalVoteChoose)
		data:add_bool(voteInProgress)
		pvote:send(player,data)
	end	
	
	function inGame()
		local count = 0
		
		for p in game_players() do
			if p:team() ~= 0 then
				count = count + 1
			end
		end
		return count
	end
	
	function bindings.playerUpdate(p)
		if voteInProgress then
			if AUTH then
				voteTime = voteTime + 1
				if voteTime > 3000 or (vote["yes"]+vote["no"]) == inGame() then
					if vote["yes"] > vote["no"] then
						if globalVote == "killslimit" or globalVote == "timelimit" or globalVote == "deathslimit" then
							console["pm_sv_"..globalVote] = globalVoteChoose
						else
							console[globalVote] = globalVoteChoose
						end
					end
					voteTime = 0
					voteInProgress = false
					globalVote = ""
					globalVoteChoose = ""
					vote["yes"] = 0
					vote["no"] = 0
					p:data().canVote = true
					for player in game_players() do
						p:data().canVote = true
						--voteStop:send(player)
						syncVote(player)
					end
					
				end	
			end
		else
			p:data().canVote = true
		end
	end
			
	function bindings.viewportRender(viewport, worm)
		local bitmap = viewport:bitmap()
		local p = worm:player()
		
		if voteInProgress and p:team() ~= 0 then
			if globalVote ~= nil and globalVoteChoose ~= nil then
				fonts.liero:render(bitmap,"CALLED VOTE: "..globalVote.."  "..globalVoteChoose, bitmap:w()/36, 100, color(255, 255, 0), Font.Shadow)
	
				fonts.liero:render(bitmap,"Y: "..vote["yes"]..", N: "..vote["no"], bitmap:w()/36, 109, color(255, 255, 0), Font.Shadow)
			end
		end
	end

	console_register_command("CALLVOTE", function(vote, voteChoose, other)
		if vote == nil then
			return 'Available votes: 05KICK00'	
		end
		
		if vote ~= nil and not voteInProgress then
			if tostring(vote) and string.lower(vote) == "map" or string.lower(vote) == "kick" or string.lower(vote) == "killslimit" or string.lower(vote) == "deathslimit" or string.lower(vote) == "timelimit" then
				if voteChoose ~= nil and tostring(voteChoose) then
					voteInProgress = true
					globalVote = vote
					if other ~= nil then
						globalVoteChoose = voteChoose.." "..other
					else
						globalVoteChoose = voteChoose
					end
					local b = new_bitstream()
					for player in game_players() do
						player:data().canVote = true
						syncVote(player)
					end
				end
			end
		end			
	end)
	
	for local_player_index = 0,1 do
		console_register_command("P"..local_player_index.."_VOTE",function(str)
			if game_local_player(local_player_index) then
				if str ~= nil then
					if tostring(str) and voteInProgress and game_local_player(local_player_index):data().canVote and game_local_player(local_player_index):team() ~= 0 then
						game_local_player(local_player_index):data().canVote = false
						if str == 'yes' then
							vote["yes"] = vote["yes"] + 1
							game_local_player(local_player_index):data().canVote = false
							for player in game_players() do
								syncVote(player)
							end
						end
		
						if str == 'no' then
							vote["no"] = vote["no"] + 1
							game_local_player(local_player_index):data().canVote = false
							for player in game_players() do
								syncVote(player)
							end
						end
					else
						return "YOU'VE ALREADY VOTED"
					end
				end
			end
		end)
	end
end
